function [qiwagott,N] = kivag(minta,hossz,szint,delay)
%
% [KIVAGOTT,N] = KIVAG(MINTA,HOSSZ,SZINT,ELTOLS);
% MINTA: ebbl vgjuk ki a mintkat;
% HOSSZ: a kivgand mintk hossza;
% SZINT: e szint felett tranziensnek tekintjk az sszetevt;
% ELTOLS: ksleltets az utols tranziens-sszetev s az els kivgand
% minta kztt;
% N = ennyi megtsmintt vgtunk ki.
% 
% 
% 
% \
%  \       ELTOLAS
%   \    |<------>|
%    \__ |        |                  
% ......\...............................  SZINT
%        \        |
%         \__     |
%            \___ |
%                \|___
%                 |   \______
%                 |          \_____
%                 |                \
%                 |                 \___________
%                 |                      |      \
%                 |    kivagott resz     |       \__________ : MINTA burkoloja
%                 |<====================>|
%                        HOSSZ

if (delay<=0)
    delay=1;
end

absz = abs(minta); % abszolt-rtk kpzse
tranz = find(absz >= szint); % 'szint'-nl nagyobb mintk a tranziens rszei
start = tranz(1); % els megts els tranziens-sszetevjnek helye (x-koordinta)
index = 1;
l = length(tranz); 

if (hossz+delay) > 5000
    szelesseg = hossz+delay;
else szelesseg = 5000; % tapasztalat alapjn: kt szomszdos megts kzti tvolsg min. 5000 pont
end

for k = 2:l,
    if tranz(k) > (start+szelesseg)% ez a tranziens-sszetev mr a kvetkez megtshez tartozik
        start = tranz(k); % kvetkez megts els tranziens-sszetevje
        kivagott(index:(index+hossz-1)) = minta((tranz(k-1)+delay):(tranz(k-1)+delay+hossz-1)); % kivgjuk az elz megts 'j' mintit
        index = index + hossz;
    end
    if k == l,
        kivagott(index:(index+hossz-1)) = minta((tranz(l)+delay):(tranz(l)+delay+hossz-1));
    end
end

M = length(kivagott)/hossz;


% a rossz mintk kiszrse (tipikusan mikor kt megts kztt nincs meg a min. (hossz+delay) idkz)
index = 1;
for k = 1:M,
    temp = kivagott(((k-1)*hossz+1):(k*hossz));
    if max(abs(temp)) < szint
        qiwagott(((index-1)*hossz+1):(index*hossz)) = temp; 
        index = index + 1;
    end
end
figure(10101)
plot(qiwagott), grid;

N = length(qiwagott)/hossz;